UNIT mTTurtle;

interface


//--------------------  ggf Uses-Liste einfgen !  --------------------
//uses ....;

type
   TTurtle = CLASS

     // weitere Attribute
     private
        Fsichtbar : boolean;
        Fstiftunten : boolean;
        Fw : real;
        Fx : real;
        Fy : real;

     // weitere Methoden
     public
        procedure fd(schritte:real);
        procedure lt(winkel:real);
        procedure rt(winkel:real);
        procedure SetPos(x,y:real);
        procedure SetSichtbar(pFsichtbar:boolean);
        procedure SetStiftunten(unten:boolean);
        procedure SetW(winkel:real);
        function GetSichtbar : boolean;
        function GetStiftunten : boolean;
        function GetW : real;
        function GetX : real;
        function GetY : real;

   end;

implementation

//+---------------------------------------------------------------------
//|         TTurtle: Methodendefinition 
//+---------------------------------------------------------------------

//-------- fd (public) -------------------------------------------------
procedure TTurtle.fd(schritte:real);
begin
  Fx := Fx + cos(GetW/180*pi)*schritte;
  Fy := Fy + sin(GetW/180*pi)*schritte;
end;

//-------- lt (public) -------------------------------------------------
procedure TTurtle.lt(winkel:real);
begin
  setW(GetW + winkel);
end;

//-------- rt (public) -------------------------------------------------
procedure TTurtle.rt(winkel:real);
begin
  setW(GetW - winkel);
end;

//-------- SetPos (public) ---------------------------------------------
procedure TTurtle.SetPos(x,y:real);
begin
  Fx := x; Fy := y;
end;

//-------- SetSichtbar (public) ----------------------------------------
procedure TTurtle.SetSichtbar(pFsichtbar:boolean);
begin
  Fsichtbar := pFsichtbar
end;

//-------- SetStiftunten (public) --------------------------------------
procedure TTurtle.SetStiftunten(unten:boolean);
begin
  FStiftUnten := unten;
end;

//-------- SetW (public) -----------------------------------------------
procedure TTurtle.SetW(winkel:real);
begin
  Fw := winkel;
  while Fw < 0 do Fw := Fw + 360.0;
  while Fw >= 360 do Fw := Fw - 360.0;
end;

//-------- GetSichtbar (public) ----------------------------------------
function TTurtle.GetSichtbar : boolean;
begin
  result  := Fsichtbar
end;

//-------- GetStiftunten (public) --------------------------------------
function TTurtle.GetStiftunten : boolean;
begin
  result := FStiftUnten;
end;

//-------- GetW (public) -----------------------------------------------
function TTurtle.GetW : real;
begin
  result  := Fw;
end;

//-------- GetX (public) -----------------------------------------------
function TTurtle.GetX : real;
begin
  result  := Fx;
end;

//-------- GetY (public) -----------------------------------------------
function TTurtle.GetY : real;
begin
  result  := Fy;
end;

end.
