unit uBaum;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs,mTTurtleWelt, StdCtrls;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
  private
    TW : TTurtleWelt;
    procedure warte(t : longint);
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  TW := TTurtleWelt.Create(-512,512,-384,384,canvas,width,height);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  TW.Free;
end;

procedure TForm1.FormPaint(Sender: TObject);

  procedure zeichneFigur(t : integer; a : real);
  const
    alpha = 36.86989765;
    beta  = 53.13010235;
    tf    = 5; // Rekursionstiefe fr Farbwechsel
  begin
    if t < tf then canvas.Pen.Color := clGreen
              else canvas.Pen.Color := clBlack;
    if t = 0
    then
      TW.fd(a)
    else
    begin
      TW.fd(a); TW.lt(90); TW.fd(a); TW.lt(90);
      TW.fd(a); TW.lt(90); TW.fd(a);
      TW.rt(180); TW.fd(a); TW.rt(beta);
      if t > 0
      then
        zeichneFigur(t-1,0.8*a)
      else
        TW.fd(0.8*a);
      TW.rt(90);
      if t > 0
      then
        zeichneFigur(t-1,0.6*a)
      else
        TW.fd(0.6*a);
      if t < tf then canvas.Pen.Color := clGreen
                else canvas.Pen.Color := clBlack;
      TW.rt(alpha);
      TW.fd(a); TW.lt(90);
    end;
  end;
  
begin
  TW.SetPos(0,-300);
  zeichneFigur(20,150);
end;

procedure TForm1.warte(t: longint);
var
  a: longint;
begin
  a := GetTickCount;
  repeat
    Application.ProcessMessages;
  until (GetTickCount > a+t);
end;

end.
